import 'dart:math';

import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:get/get.dart';
import 'package:intl/intl.dart';
import 'package:intl/date_symbol_data_local.dart';


DateTime? toDateTime(dynamic date){
  if(date == null) return null;
  if (date is String){
    List _type = date.split(' ');
    List _date = _type[0].split('/');
    List _time = _type[1].split(':');
    if(_time.length == 2) _time.add('0');
    return DateTime(int.parse(_date[0]),int.parse(_date[1]),int.parse(_date[2]),int.parse(_time[0]),int.parse(_time[1]), int.parse(_time[2]));
  }
  if(date is Timestamp) return date.toDate();
  if(date is int) return DateTime.fromMillisecondsSinceEpoch(date);
  return null;
}


String? dateToString(DateTime? date) => date == null ? null:'${date.year}/${date.month}/${date.day} ${date.hour}:${date.minute}:${date.second}';

extension DateTimeFormat on DateTime{
  String get fullDate => format('MMM d, yyyy - HH:mm a');
  String get ago {
        int min = DateTime.now().difference(this).inMinutes;
        int count = 0;
        String text = '';
        if(min < 60) {
          count = max(min, 0);
          text = 'm';
        }
        else if(min < 60 * 24) {
          count = min ~/60;
          text = 'h';
        }
        else if(min < 60 * 24 * 7) {
          count = min ~/(60 * 24);
          text = 'd';
        }
        else {
          count = min~/(60*24*7);
          text = 'w';
        }
        text = text.tr;
        return Get.locale?.languageCode == 'ar' ? '${'ago'.tr} $count $text':'$count $text ${'ago'.tr}';
      }

  String format(String format){
    initializeDateFormatting();
    return DateFormat(format, Get.locale?.languageCode).format(this);
  }

  DateTime get withoutTime => DateTime(year, month, day);
  DateTime get onlyMonth => DateTime(year, month);
  Timestamp get stamp => Timestamp.fromDate(this);
}

