library convert_money;

import 'dart:math' as math;


RegExp reg = RegExp(r'(\d{1,3})(?=(\d{3})+(?!\d))');
String mathFunc(Match match) => '${match[1]},';

String convertMoney(int data)=>data.toString().replaceAllMapped(reg, mathFunc);

extension StringToCurrency on String{
  String get toCurrency => replaceAllMapped(reg, mathFunc);
}

extension StringSplit on String{
  List<String> get urls{
    RegExp exp = RegExp(r'(?:(?:https?|ftp):\/\/)?[\w/\-?=%.]+\.[\w/\-?=%.]+');
    Iterable<RegExpMatch> matches = exp.allMatches(this);

    var texts = split(exp);
    var links = matches.map((e) => substring(e.start, e.end));
    for(int i =0; i < links.length; i++){
      texts.insert(i+i+1, links.elementAt(i));
    }
    return texts;
  }
}

// extension IntToCurrency on num?{
//   String get toCurrency => toString().toCurrency;
// }
extension NullableIntToCurrency on num?{
  String get toCurrency => this == null ? '0':toString().toCurrency;
}

extension MaxMinIterable on Iterable<int> {
  int get max => reduce(math.max);

  int get min => reduce(math.min);
}

extension StringCasingExtension on String {
  String toCapitalized() => isNotEmpty ?'${this[0].toUpperCase()}${substring(1)}':'';
  String toTitleCase() => replaceAll(r'$', ' ').replaceAll(RegExp(' +'), ' ').split(" ").map((str) => str.toCapitalized()).join(" ");
}

extension Generator on String{
  List<String> get generateSearchTerms{
    List<String> terms = [];
    for (int i = 0; i < length; i++) {
      for (int j = 0; j < length - i; j++) {
        terms.add(substring(j, i + j + 1));
      }
    }
    return terms;
  }
}